//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  Red
#property indicator_color2  DimGray
#property indicator_color3  LimeGreen
#property indicator_color4  Red
#property indicator_color5  DimGray
#property indicator_color6  LimeGreen
#property indicator_color7  Silver
#property indicator_color8  Silver
#property indicator_style2  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property indicator_style8  STYLE_DOT
#property indicator_width7  2

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    BandsPrice       = 8;
extern double UpDeviation      = 2.0;
extern double DnDeviation      = 2.0;
extern double SwingCount       = 1.0;
extern double Speed            = 1.0;
extern double rangePeriod      = 2.0;
extern double Phase            = 0.0;
extern bool   Double           = false;
extern int    FutureBars       = 100;
extern bool   SkipSunday       = false;
extern bool   Interpolate      = true;
extern bool   ShowLrLine       = false;

extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double bandup[];
double banddn[];
double bandmi[];
double banfup[];
double banfdn[];
double banfmi[];
double lrvalue[];
double lrforecast[];
double swingBuffer[];
double breakouts[];

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   returnFutureSlope;
bool   calculateValue;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   SetIndexBuffer(0,bandup);
   SetIndexBuffer(1,bandmi);
   SetIndexBuffer(2,banddn);
   SetIndexBuffer(3,banfup);
   SetIndexBuffer(4,banfmi);
   SetIndexBuffer(5,banfdn);
   SetIndexBuffer(6,lrvalue);
   SetIndexBuffer(7,lrforecast);
   
   if (ShowLrLine)
   {
   SetIndexStyle(6,DRAW_LINE);     
   }
   
   else
   {
   SetIndexStyle(6,DRAW_NONE);
   }
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnFutureSlope = (TimeFrame=="returnFutureSlope"); if (returnFutureSlope) { calculateValue=true; return(0); }
         calculateValue    = (TimeFrame=="calculateValue");    if (calculateValue)                           return(0);
         returnBars        = (TimeFrame=="returnBars");        if (returnBars)                               return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
   
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,k,n,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { bandup[0] = limit+1; return(0); }
         if (ArraySize(breakouts)!=Bars) ArrayResize(breakouts,Bars);

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (ArraySize(swingBuffer)!=Bars) ArrayResize(swingBuffer,Bars);
      for(i=limit; i>=0; i--) 
      {
         int swing = 0,d=0;
         if (!isSunday(i,0))
         {
            if (High[i] > High[i+1] && High[i+1] > High[i+2] && Low[i+2] < Low[i+3]  && Low[i+3]  < Low[i+4])  swing = -1;
            if (Low[i]  < Low[i+1]  && Low[i+1]  < Low[i+2]  && High[i+2]> High[i+3] && High[i+3] > High[i+4]) swing =  1;
         }
         swingBuffer[Bars-i-1] = swing;
            for (k=i,n=0; (k<Bars) && (n<SwingCount); k++) { if(swingBuffer[Bars-k-1]!=0) n++; if (isSunday(k,0)) d++; } 
            int BandsPeriod = MathMax(MathRound((k-d-i)/SwingCount/Speed),1);
   
         //
         //
         //
         //
         //
       
         double slope;      
         double linreg = iLRValue(getPrice(BandsPrice,i),BandsPeriod,i,slope);
         double range  = CalculateRange(rangePeriod,i);
            lrvalue[i] = linreg;
            if (i>Bars-1)
            {
               bandup[i] = linreg;
               banddn[i] = linreg;
               bandmi[i] = linreg;
               continue;
            }         
         
         //
         //
         //
         //
         //
         
         bandup[i] = bandup[i+1];
         bandmi[i] = bandmi[i+1];
         banddn[i] = banddn[i+1];
         if (linreg>bandup[i+1] || linreg<banddn[i+1])
         {
            bandup[i] = linreg + UpDeviation * range;
            banddn[i] = linreg - DnDeviation * range;
            bandmi[i] = linreg;
         }
         
         //
         //
         //
         //
         //
         
         if (i==0)
         {
            for (int cross=0; cross<FutureBars; cross++)
            {
               double value = linreg+slope*cross;
                  if (value > bandup[0]) break;
                  if (value < banddn[0]) break;
            }
            for (k=0; k<=cross; k++)
            {
               banfup[cross-k]     = bandup[0];
               banfdn[cross-k]     = banddn[0];
               banfmi[cross-k]     = bandmi[0];
               lrforecast[cross-k] = linreg+slope*k;
            }
         }
         
         //
         //
         //
         //
         //
         
         breakouts[Bars-i-1] = breakouts[Bars-i-2];
            if (lrvalue[i]>bandup[i+1])                           breakouts[Bars-i-1]= 1;
            if (lrvalue[i]<banddn[i+1])                           breakouts[Bars-i-1]=-1;
            if (lrvalue[i]>bandup[i+1] && lrvalue[i]<bandup[i+1]) breakouts[Bars-i-1]= 0;
      }
      
      //
      //
      //
      //
      //
      
      if (!calculateValue)
      {
         SetIndexShift(3,cross); SetIndexDrawBegin(3,Bars-cross-1);
         SetIndexShift(4,cross); SetIndexDrawBegin(4,Bars-cross-1);
         SetIndexShift(5,cross); SetIndexDrawBegin(5,Bars-cross-1);
         SetIndexShift(7,cross); SetIndexDrawBegin(7,Bars-cross-1);
      }
      if (returnFutureSlope) bandup[0]=slope; else manageAlerts();
      return(0);
   }      
 
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         bandup[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPrice,UpDeviation,DnDeviation,SwingCount,Speed,rangePeriod,Phase,Double,FutureBars,SkipSunday,0,y);
         bandmi[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPrice,UpDeviation,DnDeviation,SwingCount,Speed,rangePeriod,Phase,Double,FutureBars,SkipSunday,1,y);
         banddn[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPrice,UpDeviation,DnDeviation,SwingCount,Speed,rangePeriod,Phase,Double,FutureBars,SkipSunday,2,y);
         lrvalue[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPrice,UpDeviation,DnDeviation,SwingCount,Speed,rangePeriod,Phase,Double,FutureBars,SkipSunday,6,y);
         
            //
            //
            //
            //
            //
            
            int barToCheck = iBarShift(NULL,0,iTime(NULL,timeFrame,y+1));
               breakouts[Bars-i-1] = breakouts[Bars-i-2];
                  if (lrvalue[i]>bandup[barToCheck])                                  breakouts[Bars-i-1]= 1;
                  if (lrvalue[i]<banddn[barToCheck])                                  breakouts[Bars-i-1]=-1;
                  if (lrvalue[i]>bandup[barToCheck] && lrvalue[i]<bandup[barToCheck]) breakouts[Bars-i-1]= 0;
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(k = 1; k < n; k++)
               lrvalue[i+k]  = lrvalue[i] + (lrvalue[i+n]-lrvalue[i])*k/n;
   }

   //
   //
   //
   //
   //
      
   slope  = iCustom(NULL,timeFrame,indicatorFileName,"returnFutureSlope",BandsPrice,SwingCount,UpDeviation,DnDeviation,Speed,rangePeriod,Phase,Double,FutureBars,SkipSunday,0,0)*Period()/timeFrame;
   linreg = lrvalue[0];
      for (cross=0; cross<FutureBars*timeFrame/Period(); cross++)
      {
         value = linreg+slope*cross;
           if (value > bandup[0]) break;
           if (value < banddn[0]) break;
      }
      for (k=0; k<=cross; k++)
      {
           banfup[cross-k]     = bandup[0];
           banfdn[cross-k]     = banddn[0];
           banfmi[cross-k]     = bandmi[0];
           lrforecast[cross-k] = linreg+slope*k;
      }

   //
   //
   //
   //
   //

   SetIndexShift(3,cross); SetIndexDrawBegin(3,Bars-cross-1);
   SetIndexShift(4,cross); SetIndexDrawBegin(4,Bars-cross-1);
   SetIndexShift(5,cross); SetIndexDrawBegin(5,Bars-cross-1);
   SetIndexShift(7,cross); SetIndexDrawBegin(7,Bars-cross-1);
   manageAlerts();
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7 : return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      case 8 : return((Open[i]+High[i]+Low[i]+Close[i]+Close[i])/5.0);
      default : return(iMA(NULL,0,1,0,MODE_SMA,MathMax(MathMin(type,6),0),i));
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double CalculateRange(int BandsPeriod, int i)
{
   int j,k;
   double lsum   = (BandsPeriod+1) * iDSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW, i),rangePeriod,Phase,i, 0);
   double hsum   = (BandsPeriod+1) * iDSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i),rangePeriod,Phase,i,20);
   double sumw   = (BandsPeriod+1);
   
   //
   //
   //
   //
   //
      
   for(j = 1, k = BandsPeriod; j <= BandsPeriod; j++, k--)
   {
      lsum += k * iDSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW, i+j),rangePeriod,Phase,i+j, 0);
      hsum += k * iDSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i+j),rangePeriod,Phase,i+j,20);
      sumw += k;

      if (j <= i)
      {
         lsum += k * iDSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW, i-j),rangePeriod,Phase,i-j, 0);
         hsum += k * iDSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i-j),rangePeriod,Phase,i-j,20);
         sumw += k;
      }
   }
return (hsum/sumw - lsum/sumw);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double workLr[];
double iLRValue(double value, int period, int i, double& slope)
{
   if (ArraySize(workLr)!=Bars) ArrayResize(workLr,Bars); int r = Bars-i-1;
                 workLr[r] = value;
                 if (r<period) return(value);
                 
   //
   //
   //
   //
   //
                    
   double sumX    = period * (period-1) / 2.0;
   double sumXX   = period * (period-1) * (2.0 * period - 1.0) / 6.0;
   double divisor = MathPow(sumX,2.0) - period * sumXX;
   double SumXY   = 0;
   double SumY    = 0;

         int k=0,d=0;
         for (; k<period; d++)
            if (!isSunday(i,d))
               {
                  SumXY += k*workLr[r-d];
                  SumY  +=   workLr[r-d];
                  k++;
               }                  
   
   //
   //
   //
   //
   //
   
   if( divisor != 0 ) 
         	slope = (period * SumXY - sumX * SumY)/divisor;
   else     slope = 0; 
   return((SumY-slope*sumX)/period + slope*(period-1));
}
bool isSunday(int i, int d) { return(SkipSunday && TimeDayOfWeek(Time[i+d])==0); }


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar))-1;
      
      //
      //
      //
      //
      //
      
      if (breakouts[whichBar] != breakouts[whichBar-1])
      {
         if (breakouts[whichBar] == 1) doAlert(whichBar,"up");
         if (breakouts[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," alb Mogalef bands breakout ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"alb Mogalef bands"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

